(function($) {
    'use strict';

    moment.locale(oscar_lang);
    var cart_items = typeof selected_accos != 'undefined' ? selected_accos : [];
    var different_date_cart_item;
    var different_date_quantity;

    $('.btn-select-rate').on('click', function() {
        $(this).next().slideToggle('fast', function() {});
    });

    $('.rate-list .rate').on('click', function() {
        if ($(this).hasClass('selected')) {
            return;
        }
        $(this).addClass('selected').siblings().removeClass('selected');
        var price = $(this).data('price');
        var orig_price = $(this).data('orig-price');
        var sorted = $(this).data('sorted');
        var rate_block = $(this).closest('.rate-block');
        var acco_element = $(this).closest('.accommodation-element');
        var range_type = acco_element.data('range');
        var acco_id = parseInt(acco_element.data('id'));
        var arrival = acco_element.data('arrival');
        var departure = acco_element.data('departure');

        acco_element.data('adults', $(this).data('adults'));
        acco_element.data('children', $(this).data('children'));
        acco_element.data('price', $(this).data('price'));
        acco_element.data('sorted', $(this).data('sorted'));

        var acco_selected = accommodations[range_type][
                arrival + '_' + departure
            ][acco_id];
        var conditions_btn = '<div class="conditions modal-button" '
            + 'role=button data-modal=conditions-modal>'
            + '<a><span class="dashicons dashicons-info"></span>'
            + trans_strings.conditions + '</a></div>';
        var selected_rate_has_promo = false;
        var rate_name = '';
        var html = '';

        // Update accommodation's selected rate
        for (var key_price in acco_selected['periods']) {
            if (parseFloat(key_price) == price) {
                var rate_parts = acco_selected['periods'][key_price][sorted];
                if (rate_parts.length == 1) {
                    // Uncombined
                    selected_rate_has_promo = 'orig_price' in rate_parts[0];
                    var rate = getRate(
                        inventory_rates,
                        rate_parts[0].rate_id
                    );
                    if (rate) {
                        rate_name += getOccupancyIcons(rate);
                    }
                    rate_name += availability_rates[rate_parts[0].rate_id].name;
                    html += '<div class=name>' + rate_name + '</div>' + conditions_btn;
                    acco_element.data('rate', rate_parts[0].rate_id);
                }
                else {
                    // Combined
                    var rate_ids = '';
                    html += '<div class=name>' + trans_strings.combined_rates + '</div>'
                        + conditions_btn + '<ul class=combined-rates>';
                    for (var i=0; i<rate_parts.length; i++) {
                        html += '<li>' + availability_rates[rate_parts[i].rate_id].name
                            + (rate_parts[i].night_string) + '</li>';
                        if (i > 0) {
                            rate_ids += ',' + rate_parts[i]['rate_id'];
                        }
                        else {
                            rate_ids += rate_parts[i]['rate_id'];
                        }
                    }
                    acco_element.data('rate', rate_ids);
                    html += '</ul>';
                }
                break;
            }
        }
        html += '<div class=price>'
            + '<div class=ohbe-title>' + trans_strings.per_night + ':</div>';
        if (selected_rate_has_promo) {
            html += '<div class="value orig">'
                + '<span>' + formatPrice(orig_price / acco_selected.nights) + '</span>'
                + '</div></div>'
                + '<div class=promo>'
                + '<div class="ohbe-title tag">' + acco_selected.promo_code + '</div>'
                + '<div class=value>' + formatPrice(price / acco_selected.nights)
                + '</div>';
        }
        else {
            html += '<div class=value>';
            if ($(this).is(':first-child')) {
                html += '<div class="tag best-price">'
                    + trans_strings.best_price + '</div>';
            }
            html += formatPrice(price / acco_selected.nights) + '</div></div>';
        }
        html += '</div></div>';

        // Change rate with another rate and quantity selected
        for (var key in cart_items) {
            if (
                cart_items[key].acco_id == acco_id
                && cart_items[key].arrival == arrival
                && cart_items[key].departure == departure
            ) {
                cart_items[key].price = acco_element.data('price');
                cart_items[key].rate = acco_element.data('rate');
                cart_items[key].sorted = acco_element.data('sorted');
                cart_items[key].adults = acco_element.data('adults');
                cart_items[key].children = acco_element.data('children');

                updateAccoCardTotalPrice(
                    $(this).closest('.rate-block'),
                    parseInt(acco_element.find('.accos-quantity .value').val()),
                    selected_rate_has_promo
                );
                setCartItemList();
                scrollToCart();
                break;
            }
        }
        rate_block.find('.info').html(html).fadeIn(1000);
        rate_block.find('.quantity-total-block').fadeIn(1000);
        $(this).closest('.rate-list').slideUp('fast', function() {});
    });

    $(document).on('change','.accos-quantity .value', function() {
        var acco_element = $(this).closest('.accommodation-element');
        var arrival = acco_element.data('arrival');
        var departure = acco_element.data('departure');
        var quantity = parseInt($(this).val());
        var acco_id = parseInt(acco_element.data('id'));
        var is_selected = false;

        if (
            Object.keys(cart_items)[0]
            && (cart_items[Object.keys(cart_items)[0]]['arrival'] != arrival
                || cart_items[Object.keys(cart_items)[0]]['departure'] != departure)
        ) {
            different_date_cart_item = acco_element;
            different_date_quantity = quantity;
            $('body').removeClass('with-overlay').addClass('with-overlay');
            $('#ohbe-different-dates').show();
            return;
        }
        // Check if item already existed in cart list
        for (var i=0; i<cart_items.length; i++) {
            if (cart_items[i].acco_id == acco_id) {
                if (quantity > 0) {
                    cart_items[i].quantity = quantity;
                }
                else {
                    cart_items.splice(i, 1);
                    $('.accommodation-booked-list').find('[data="' + acco_id + '"]')
                        .parent().remove();
                    acco_element.removeClass('selected');
                }
                is_selected = true;
                break;
            }
        }
        // Add item into cart list
        if (!is_selected) {
            cart_items.push({
                range: acco_element.data('range'),
                quantity: quantity,
                acco_id: acco_id,
                name: availability_accos[acco_id].name,
                arrival: arrival,
                arrival_string: moment(arrival).format('ddd D MMM YYYY'),
                departure: departure,
                departure_string: moment(departure).format('ddd D MMM YYYY'),
                amount: acco_element.data('amount'),
                adults: parseInt(acco_element.data('adults')),
                children: parseInt(acco_element.data('children')),
                price: parseFloat(acco_element.data('price')),
                rate: acco_element.data('rate'),
                sorted: parseFloat(acco_element.data('sorted')),
                excl_taxes: acco_element.data('taxes') || 0
            });
            acco_element.addClass('selected');
        }
        updateAccoCardTotalPrice($(this).closest('.rate-block'), quantity);
        setCartItemList();
        if (cart_items.length > 0) {
            scrollToCart();
        }
    });

    $(document).on('click','.delete-acco', function() {
        var acco_selected = $(this).closest('.accommodation-booked');
        for (var i=0; i<cart_items.length; i++) {
            if (cart_items[i].acco_id == parseInt(acco_selected.data('id'))) {
                var acco_element = $('.accommodation-list')
                    .find('.accommodation-element[data-id="'
                    + cart_items[i].acco_id + '"]');
                var quantity_total_block = acco_element
                    .find('.rate-block .quantity-total-block');
                acco_element.removeClass('selected');
                quantity_total_block.find('.accos-quantity .value').val(0);
                quantity_total_block.find('.total .value').html(formatPrice(0));
                quantity_total_block.find('.total').hide();
                quantity_total_block.find('.total-promo').hide();
                acco_selected.remove();
                cart_items.splice(i, 1);
            }
        }
        setCartItemList();
    });

    $('#ohbe-booking-summary-form').on('submit', function() {
        $('#ohbe-accommodations-input').val(JSON.stringify(cart_items));
    });

    $(document).on('click', '.conditions', function() {
        var acco_element = $(this).closest('.accommodation-element');
        var acco_rates = acco_element.data('rate').toString().split(',');
        var html = '';

        $.each(acco_rates, function (i, rateId) {
            var available_rate = availability_rates[rateId];
            var inventory_rate = getRate(inventory_rates, rateId);

            if (typeof available_rate != 'undefined' && available_rate.name != null) {
                html += '<div class=rate-header>';
                if (inventory_rate['adults'] > 5) {
                    html += '<div class="dashicons dashicons-admin-users"' +
                        'title="' + trans_strings.adults + '">' +
                        '</div>×' + inventory_rate['adults'];
                }
                else {
                    for (i=0; i<inventory_rate['adults']; i++) {
                        html += '<div class="dashicons dashicons-admin-users"' +
                            'title="' + trans_strings.adults + '">' +
                            '</div>';
                    }
                }
                if (inventory_rate['adults'] > 5 || inventory_rate['children'] > 5) {
                    html += '<span></span>';
                }
                if (inventory_rate['children'] > 5) {
                    html += '<div class="dashicons dashicons-universal-access" '
                        + 'title="' + trans_strings.children + '">'
                        + '</div>×' + inventory_rate['children'];
                }
                else {
                    for (i=0; i<inventory_rate['children']; i++) {
                        html += '<span class="dashicons dashicons-universal-access" '
                            + 'title="' + trans_strings.children + '"></span>';
                    }
                }
                html += '<h4 class=header>' + available_rate.name + '</h4></div>';
                if (available_rate.description) {
                    html += '<h4 class=header>' + trans_strings.description + '</h4>'
                        + '<p>' + available_rate.description
                        .replace("/\r\n|\r|\n/",'<br/>') + '</p>';
                }
                if (available_rate.payment) {
                    html += '<h4 class=header>' + trans_strings.payment + '</h4>' +
                        '<p>' + available_rate.payment
                        .replace("/\r\n|\r|\n/",'<br/>') + '</p>';
                }
                if (available_rate.cancellation) {
                    html += '<h4 class=header>' + trans_strings.cancellation + '</h4>'
                        + '<p>' + available_rate.cancellation
                        .replace("/\r\n|\r|\n/",'<br/>') + '</p>';
                }
            }

        });

        $('#ohbe-conditions-modal .rate-content').html(html);
    });

    $(document).on('click', '.modal-button',function() {
        var data_modal = $(this).data('modal');
        if (data_modal == 'description-modal') {
            var acco_id = $(this).closest('.accommodation-element').data('id');
            var title = $(this).closest('.accommodation-element').data('name');
            var body = '';
            var description = availability_accos[acco_id]['description'];
            $.each(inventory_accos, function(i, value) {
                if (acco_id == value['id'] && value['image_url']) {
                    body += '<div class=modal-image>'
                        + '<img src="' + value['image_url'] + '" '
                        + 'alt="' + value['name'] + '">'
                        + '</div>';
                }
            });
            if (description) {
                body += '<div class=description>'
                    + description.replace(/\n/g, '<br>')
                    + '</div>';
            }
            $('#ohbe-description-modal .modal-title').html(title);
            $('#ohbe-description-modal .modal-body').html(body);
        }

        $('body').removeClass('with-overlay').addClass('with-overlay');
        // Move modal to body
        $('#ohbe-' + data_modal).detach().appendTo('body');
        $('#ohbe-' + data_modal).show();
    });

    $('.ohbe-modal .close, .ohbe-modal .accept, .more').on('click', function() {
        $(this).closest('.ohbe-modal').hide();
        $('body').removeClass('with-overlay');
    });

    $('#ohbe-different-dates-yes').on('click', function() {
        var arrival = different_date_cart_item.data('arrival');
        var departure = different_date_cart_item.data('departure');
        var acco_id = parseInt(different_date_cart_item.data('id'));
        var price = parseFloat(different_date_cart_item.data('price'));

        cart_items = [];
        cart_items.push({
            range: different_date_cart_item.data('range'),
            quantity: different_date_quantity,
            acco_id: acco_id,
            name: availability_accos[acco_id].name,
            arrival: arrival,
            arrival_string: moment(arrival).format('ddd D MMM YYYY'),
            departure: departure,
            departure_string: moment(departure).format('ddd D MMM YYYY'),
            amount: different_date_cart_item.data('amount'),
            adults: parseInt(different_date_cart_item.data('adults')),
            children: parseInt(different_date_cart_item.data('children')),
            price: price,
            rate: different_date_cart_item.data('rate'),
            sorted: parseFloat(different_date_cart_item.data('sorted')),
            excl_taxes: different_date_cart_item.data('taxes') || 0,
            periods: []
        });

        $('.accommodation-element').removeClass('selected');
        var quantity_total_block = $('.quantity-total-block');
        quantity_total_block.find('.accos-quantity .value').val(0);
        quantity_total_block.find('.total .value').text(formatPrice(0));
        quantity_total_block.find('.total').hide();
        quantity_total_block.find('.total-promo').hide();
        updateAccoCardTotalPrice(
            different_date_cart_item.find('.rate-block'),
            different_date_quantity
        );
        setCartItemList();
        scrollToCart();

        different_date_cart_item.addClass('selected');
        different_date_cart_item.find('.accos-quantity .value')
            .val(different_date_quantity);
        $('#ohbe-different-dates').hide();
        $('body').removeClass('with-overlay');
        $('.rate-list').slideUp('fast', function() {});
    });

    $('#ohbe-different-dates-no').on('click', function() {
        different_date_cart_item.find('.accos-quantity .value').val(0);
        $('#ohbe-different-dates').hide();
        $('body').removeClass('with-overlay');
    });

    $(document).keyup(function(ev){
        if (ev.keyCode == 27) { // Escape key
            $('.ohbe-modal').hide();
            $('body').removeClass('with-overlay');
        }
    });

    $('.ohbe-accordion').accordion({
        collapsible: true,
        active: false,
        heightStyle: 'content'
    });

    /**
     * Update the total price's accommodation card.
     *
     * @return void
     */
    function updateAccoCardTotalPrice(
        rate_block,
        quantity_val,
        selected_rate_has_promo
    ) {
        var quantity_total_block = rate_block.children('.quantity-total-block');
        var rate_selected = rate_block.find('.rate-list .selected');
        var total_block = quantity_total_block.find('.total');
        var total_promo_block = quantity_total_block.find('.total-promo');
        var price = rate_selected.data('price');
        var orig_price = rate_selected.data('orig-price');

        if (typeof orig_price != 'undefined' && orig_price) {
            total_block.find('.value').addClass('orig').text(formatPrice(
                parseFloat(orig_price) * quantity_val)
            );

            total_promo_block.find('.value').text(
                formatPrice(parseFloat(price) * quantity_val)
            );
            total_promo_block.show();
        }
        else {
            total_block.find('.value').removeClass('orig').text(
                formatPrice(parseFloat(price) * quantity_val)
            );
            total_promo_block.hide();
        }
        if (quantity_val > 0) {
            total_block.show();

            if (selected_rate_has_promo) {
                total_promo_block.show();
            }
        }
        else {
            total_block.hide();
            total_promo_block.hide();
        }
    }

    /**
     * Update carts' items
     *
     * @return void
     */
    function setCartItemList() {
        var total_price = 0;
        var html = '';

        for (var i=0; i<cart_items.length; i++) {
            var acco_name_quantity = cart_items[i].quantity > 1
                ? cart_items[i].quantity + ' × ' : '';
            var rate_parts = accommodations[cart_items[i].range]
                [cart_items[i].arrival + '_' + cart_items[i].departure]
                [cart_items[i].acco_id]['periods'][cart_items[i].price]
                [cart_items[i].sorted];
            var periods = [];

            html += '<div class=accommodation-booked '
                + 'data-id="' + cart_items[i].acco_id + '">'
                + getAccoImage(inventory_accos, cart_items[i].acco_id)
                + '<div class=acco-info>'
                + '<h4 class=ohbe-title>'
                + acco_name_quantity + cart_items[i].name
                + '</h4>'
                + '<div class=date>'
                + '<label class=ohbe-title>' + trans_strings.arrival + ': </label>'
                + '<div class=value>' + cart_items[i].arrival_string + '</div>'
                + '</div>'
                + '<div class=date>'
                + '<label class=ohbe-title>' + trans_strings.departure + ': </label>'
                + '<div class=value>' + cart_items[i].departure_string + '</div>'
                + '</div>'
                + '<div class=accommodation-rate>'
                + '<label class=ohbe-title>' + trans_strings.rate + ': </label>'
                + '<div class=value>';
            for (var j=0; j<rate_parts.length; j++) {
                if (j > 0) {
                    html += ', ';
                }
                html += availability_rates[rate_parts[j].rate_id].name;
                periods.push({
                    rate_id: rate_parts[j].rate_id,
                    days: rate_parts[j].days
                });
            }
            html += '</div></div>'
                + '<div class=accommodation-rate>'
                + '<label class=ohbe-title>' + trans_strings.maximum + ': </label>'
                + '<div class=value>'
                + getOccupancyIcons(rate_parts[0])
                + '</div></div>'
                + '<div class=accommodation-price>'
                + '<label class=ohbe-title>'
                + getTaxesString(cart_items[i], trans_strings) + ': </label>'
                + '<div class=value>'
                + formatPrice(cart_items[i].quantity * cart_items[i].price)
                + '</div></div>'
                + '<div class=clear></div>'
                + '</div>'
                + '<div class=delete>'
                + '<a class=delete-acco role=button>'
                + '<span class="dashicons dashicons-no"></span></a>'
                + '</div></div>';
            total_price += cart_items[i].quantity * cart_items[i].price;
            cart_items[i].periods = periods;
        }
        $('.accommodation-booked-list').html(html);
        $('.total-block .value').html(formatPrice(total_price));

        if (cart_items.length > 0) {
            $('#booking-summary').show();
        }
        else {
            $('#booking-summary').hide();
        }
    }

    /**
     * Scroll to cart.
     *
     * @return void
     */
    function scrollToCart() {
        $('html, body').stop().animate({
            scrollTop: $('#booking-summary').offset().top
        }, 500);
    }

})(jQuery);

/**
 * Get accommodation image.
 *
 * @return string Accommodation image's html structure.
 */
function getAccoImage(accos, id) {
    for (var i=0; i<accos.length; i++) {
        if (
            accos[i].id == id
            && typeof accos[i].image_url != 'undefined'
            && accos[i].image_url != null
        ) {
            return '<div class=acco-image>'
               + '<img src=' + accos[i]['image_url'] + '>'
               + '</div>';
        }
    }

    return '';
}

/**
 * Get rate information from a given list of rates.
 *
 * @return array|null Rate.
 */
function getRate(rates, rate_id) {
    for (var i=0; i< rates.length; i++) {
        if (rates[i].id == rate_id) {
            return rates[i];
        }
    }

    return null;
}

/**
 * Get occupancy icons.
 *
 * @return string Occupancy icons' html structure.
 */
function getOccupancyIcons(rate) {
    var html = '';

    if (typeof rate.adults != 'undefined' && rate.adults) {
        if (rate.adults > 5) {
            html += '<div class="dashicons dashicons-admin-users" '
                + 'title="' + trans_strings.adults + '"></div>×'+ rate.adults;
        }
        else {
            for (var j=0; j<rate.adults; j++) {
                html += '<div class="dashicons dashicons-admin-users" '
                    + 'title="' + trans_strings.adults + '"></div>';
            }
        }
    }
    if (
        (typeof rate.adults != 'undefined' && rate.adults)
        && (typeof rate.children != 'undefined' && rate.children)
        && (rate.adults > 5 || rate.children > 5)
    ) {
        html += ' + ';
    }
    if (typeof rate.children != 'undefined' && rate.children) {
        if (rate.children > 5) {
            html += '<div class="dashicons dashicons-universal-access" '
                + 'title="' + trans_strings.children + '"></div>×' + rate.children;
        }
        else {
            for (var h=0; h<rate.children; h++) {
                html += '<div class="dashicons dashicons-universal-access" '
                    + 'title="' + trans_strings.children + '"></div>';
            }
        }
    }

    return html;
}

/**
 * Get formatted price depending on inventory currency data.
 *
 * @return string Formatted price.
 */
function formatPrice(price) {
    var formatted_price = parseFloat(price).toFixed(inventory_currency.digits);
    
    if (inventory_currency.before) {
        return inventory_currency.symbol + ' ' + formatted_price;
    }

    return formatted_price + ' ' + inventory_currency.symbol;
}

/**
 * Display taxes information.
 *
 * @return string Translated taxes information.
 */
function getTaxesString(cart_item, trans_strings) {
    return cart_item.excl_taxes > 0
        ? trans_strings.excl_taxes.replace('%s%', cart_item.excl_taxes)
        : trans_strings.incl_taxes;
}
