(function($) {
    'use strict';

    $('.items-list').accordion({
        collapsible: true,
        heightStyle: 'content'
    });

    $('.accos-selected-list').accordion({
        collapsible: true,
        active: true,
        heightStyle: 'content'
    });

    $('.item-selected-list').accordion({
        collapsible: true,
        active: true,
        heightStyle: 'content'
    });

    $(document).on('click', '.btn-quantity.minus',function() {
        var quantity = $(this).siblings('.value');
        var item = $(this).closest('.item-element');
        var total = $(this).siblings('.total');
        if (parseInt(quantity.val()) > item.data('min')) {
            quantity.val(parseInt(quantity.val()) - 1);
            var price = parseInt(quantity.val()) * parseFloat(item.data('price'));
            if (item.data('daily')) {
                price = price * parseInt(item_list.days);
            }
            total.children('.value').text(formatPrice(price));
            if (quantity.val() == 0) {
                total.hide();
            }
        }
        if (parseInt(quantity.val()) == 0) {
            $(this).siblings('.subtotal').text('');
        }
        if (!item.data('selected')) {
            item.find('.btn-ohbe').prop('disabled', parseInt(quantity.val()) <= 0);
        }
        $(this).prop('disabled', quantity.val() <= item.data('min'));
        $(this).siblings('.plus').prop(
            'disabled',
            quantity.val() == item.data('plus')
        );
    });

    $(document).on('click', '.btn-quantity.plus',function() {
        var quantity = $(this).siblings('.value');
        var item = $(this).closest('.item-element');
        var total = $(this).siblings('.total');
        if (item.data('max') == '' || item.data('max') > parseInt(quantity.val())) {
            quantity.val(parseInt(quantity.val()) + 1);
            var price = parseInt(quantity.val()) * parseFloat(item.data('price'));
            if (item.data('daily')) {
                price = price * parseInt(item_list.days);
            }
            total.show();
            total.children('.value').text(formatPrice(price));
        }
        if (parseInt(quantity.val()) == 0) {
            $(this).siblings('.subtotal').text('');
        }
        item.find('.btn-ohbe').prop('disabled', parseInt(quantity.val()) <= 0);
        $(this).siblings('.minus').prop(
            'disabled',
            quantity.val() == item.data('min')
        );
        $(this).prop('disabled', quantity.val() >= item.data('max'));
    });

    $(document).on('click', '.modal-button',function() {
        var data_modal = $(this).data('modal');
        if (data_modal == 'description-modal') {
            var item_id = $(this).closest('.item-element').data('id');
            var title = '';
            var body = '';
            $.each(item_list.items, function(i, item) {
                if (item_id == item['id']) {
                    if (item['images'][0] && item['images'][0]['url']) {
                        body += '<div class=modal-image>'
                            + '<img src="' + item['images'][0]['url'] + '" '
                            + 'alt="' + item['name'] + '">'
                            + '</div>';
                    }
                    if (item['description']) {
                        body += '<div class=description>'
                            + item['description'].replace(/\n/g, '<br>')
                            + '</div>';
                    }
                    $('#ohbe-description-modal .modal-title').html(item['name']);
                    $('.modal-body').html(body);
                }
            });
        }

        $('body').removeClass('with-overlay').addClass('with-overlay');
        // Move modal to body
        $('#ohbe-' + data_modal).detach().appendTo('body');
        $('#ohbe-' + data_modal).show();
    });

    $('.ohbe-modal .close, .ohbe-modal .accept, .more').on('click', function() {
        $(this).closest('.ohbe-modal').hide();
        $('body').removeClass('with-overlay');
    });

    $(document).keyup(function(ev){
        if (ev.keyCode == 27) {  // Escape key
            $('.ohbe-modal').hide();
            $('body').removeClass('with-overlay');
        }
    });
})(jQuery);

/**
 * Get formatted price depending on inventory currency data.
 *
 * @return string Formatted price.
 */
function formatPrice(price) {
    var formatted_price = parseFloat(price).toFixed(inventory_currency.digits);

    if (inventory_currency.before) {
        return inventory_currency.symbol + ' ' + formatted_price;
    }

    return formatted_price + ' ' + inventory_currency.symbol;
}
