(function($) {
    'use strict';

    $('input[name="ohbe_card_number"]').on('propertychange input', function () {
            if ($(this).val().length < 19) {
                $(this).val(ccFormat($(this).val()));
            }
        }).on('keypress', function (e) {
            // Only allow numbers, Return, Esc and Supr keys. When max characters,
            // Only allow Esc and Supr keys.
            // Key 0: Supr
            // Key 8: Backspace
            // Keys between 48 & 57: Numbers
            if (
                e.which != 0
                && e.which != 8
                && (e.which < 48 || e.which > 57 || $(this).val().length > 20)
            ) {
                return false;
            }
        });

    $(document).on('click', '.modal-button',function() {
        var data_modal = $(this).data('modal');
        $('body').removeClass('with-overlay').addClass('with-overlay');
        $('#ohbe-' + data_modal).show();
    });

    $('.ohbe-modal .close, .ohbe-modal .accept').on('click', function() {
        $(this).closest('.ohbe-modal').hide();
        $('body').removeClass('with-overlay');
    });

    $(document).keyup(function(e){
        if (e.which == 27) {
            $('.ohbe-modal').hide();
            $('body').removeClass('with-overlay');
        }
    });
})(jQuery);

/**
 * Format credit card number. Add a space every
 * 4 digits, except last block of 6 digits.
 * Max. digits allowed: 18.
 *
 * @return string Credit card's digits.
 */
function ccFormat(value) {
    var v = value.replace(/\s+/g, '').replace(/[^0-9]/gi, '');
    var matches = v.match(/\d{4,18}/g);
    var match = matches && matches[0] || '';
    var parts = [];

    for (var i=0; i<match.length; i+=4) {
        parts.push(match.substring(i, i + 4));
    }
    if (parts.length) {
        return parts.join(' ');
    }

    return value;
}
