<?php

class OHBE_Show_Widget extends WP_Widget {

    /**
     * Add hooks to initialize the class.
     *
     * @return void
     */
    public function __construct() {
        parent::__construct(
            'ohbe_show_widget',
            __('Oscar Hotel: Look up booking', 'ohbe'),
            array('description' =>
                __('Booking lookup widget', 'ohbe')
            )
        );
    }

    /**
     * Add hook to display the widget form.
     *
     * @return void
     */
    public function form($instance) {
        $title = '';
        $ispr = 'off';

        if (isset($instance['title'])) {
            $title = $instance['title'];
        }
        if (isset($instance['ispr'])) {
            $ispr = $instance['ispr'];
        }
        // Title input
        printf(
            '<p><label for=%1$s>%2$s</label>'
            . '<input class=widefat id=%1$s name=%3$s value="%4$s"></p>',
            $this->get_field_id('title'),
            __('Title', 'ohbe'),
            $this->get_field_name('title'),
            esc_attr($title)
        );
    }

    /**
     * Add hook to update the widget.
     *
     * @return array Instance properties.
     */
    public function update($new_instance, $old_instance) {
        return array(
            'title' => !empty($new_instance['title'])
                ? strip_tags($new_instance['title'])
                : '',
            'ispr' => $new_instance['ispr']
        );
    }

    /**
     * Add hook to display the widget.
     *
     * @return void
     */
    public function widget($args, $instance) {
        $title = apply_filters('widget_title', $instance['title']);
        echo $args['before_widget'];
        if (!empty($title)) {
            echo $args['before_title'] . $title . $args['after_title'];
        }
        ohbeShowFormOutput($instance, true);
        echo $args['after_widget'];
    }
}

/**
 * Add hook to register the widget.
 *
 * @return void
 */
function loadShowWidget() {
    register_widget('ohbe_show_widget');
}

add_action('widgets_init', 'loadShowWidget');
