<?php
get_header();

$search_filters = OHBE_Tools::getSearchFilters('Y-m-d');
$errors = ohbeAvailabilityFormHandle();
$total_price = 0;

if (isset($_GET['ohbe'])):
    $all_filters = OHBE_Tools::decodeFilters($_GET['ohbe']);
    $redforts_data = OscarAPI::getAvailability(
        $search_filters['check_in'],
        $search_filters['check_out'],
        isset($all_filters['pr']) ? $all_filters['pr'] : ''
    );
    $accommodations = OHBE_Availability::getAccommodationsStructure(
        $redforts_data,
        $all_filters
    );
endif; ?>

<div class="content-area ohbe-page">
    <div class=container>
        <?php echo do_shortcode("[ohbe_main_search]");

        if (isset($errors)): ?>
            <div class="alert alert-danger">
                <?php echo $errors->get_error_message(); ?>
            </div>
        <?php endif;
        if (!isset($redforts_data['errors'])):
            if (isset($_GET['acco'])): ?>
                <form method=POST
                    action="<?php echo OHBE_Availability::renderFormAction(
                        OHBE_AVAILABILITY_PAGE
                    ); ?>">
                    <div class=show-all-accommodations>
                        <button class=btn-ohbe>
                            <?php _e('Show results for all accommodations', 'ohbe'); ?>
                        </button>
                    </div>
                </form>
            <?php endif;
            if (isset($_GET['ohbe'])): ?>
                <div id=booking-summary class=booking-summary
                    <?php echo isset($_SESSION['ohbe']['selected_accos'])
                        ? 'style="display:block";'
                        : '' ?>>
                    <h3 class=ohbe-acco-selected-list-title>
                        <?php echo _e('Selected accommodations', 'ohbe'); ?>
                    </h3>
                    <form id=ohbe-booking-summary-form method=POST
                        action="<?php echo OHBE_Availability::renderFormAction(
                            OHBE_RESERVATION_PAGE
                        ); ?>">
                        <div class=accommodation-booked-list>
                            <?php OHBE_Availability::printSelectedAccommodations(
                                $redforts_data,
                                $total_price
                            ); ?>
                        </div>
                        <div class=accommodation-booked-list-bottom>
                            <button type=submit id=next-btn
                                name=ohbe_go_reservation_page class=btn-ohbe>
                                <?php _e('Next', 'ohbe'); ?>
                                <span class="dashicons dashicons-arrow-right-alt">
                                </span>
                            </button>
                            <div class=total-block style="display:inline-block;">
                                <div class=ohbe-title>
                                    <?php _e('Total price', 'ohbe'); ?>:
                                </div>
                                <div class=value><?php
                                    echo OHBE_Tools::formatPrice($total_price); ?>
                                </div>
                            </div>
                            <div class=clearfix></div>
                        </div>
                        <input type=hidden id=ohbe-accommodations-input
                           name=accommodations>
                    </form>
                </div>
            <?php endif;
        endif;
        if (isset($_GET['ohbe'])):
            OHBE_Availability::printErrors($redforts_data);
            OHBE_Availability::printNoAccommodationsAvailable(
                $redforts_data,
                $accommodations
            );
            OHBE_Availability::printAccommodationLists(
                $accommodations,
                $redforts_data,
                $all_filters
            );
            echo OHBE_Availability::renderModals($redforts_data);
        endif; ?>
    </div>
</div>

<?php
$trans_strings  = array(
    'adults' => __('Adults', 'ohbe'),
    'arrival' => __('Arrival', 'ohbe'),
    'best_price' => __('Best price', 'ohbe'),
    'cancellation' => __('Cancellation policy', 'ohbe'),
    'children' => __('Children', 'ohbe'),
    'combined_rates' => __('Combination of rates', 'ohbe'),
    'conditions' => __('Conditions', 'ohbe'),
    'departure' => __('Departure', 'ohbe'),
    'description' => __('Description', 'ohbe'),
    'excl_taxes' => __('Price excl. %s%% taxes', 'ohbe'),
    'incl_taxes' => __('Price incl. taxes', 'ohbe'),
    'maximum' => __('Maximum', 'ohbe'),
    'payment' => __('Payment policy', 'ohbe'),
    'per_night' => __('Per night', 'ohbe'),
    'rate' => __('Rate', 'ohbe'),
);
// JS
if (isset($redforts_data['rates'])):
    wp_localize_script(
        'ohbe_availability',
        'availability_rates',
        $redforts_data['rates']
    );
endif;
if (isset($redforts_data['accos'])):
    wp_localize_script(
        'ohbe_availability',
        'availability_accos',
        $redforts_data['accos']
    );
endif;
if (isset($_SESSION['ohbe']['selected_accos'])):
wp_localize_script(
    'ohbe_availability',
    'selected_accos',
    $_SESSION['ohbe']['selected_accos']
);
endif;
wp_localize_script(
    'ohbe_availability',
    'inventory_accos',
    OHBE_Main::getInventory('accos')
);
wp_localize_script(
    'ohbe_availability',
    'inventory_rates',
    OHBE_Main::getInventory('rates')
);
wp_localize_script(
    'ohbe_availability',
    'inventory_currency',
    OHBE_Main::getInventory('currency')
);
wp_localize_script(
    'ohbe_availability',
    'oscar_lang',
    OscarAPI::getLanguage()
);
wp_localize_script(
    'ohbe_availability',
    'trans_strings',
    $trans_strings
);

get_footer();
