<?php
get_header();

$search_filters = OHBE_Tools::getSearchFilters('Y-m-d');
$redforts_data = OscarAPI::getAvailability(
    $search_filters['check_in'],
    $search_filters['check_out'],
    isset($all_filters['pr']) ? $all_filters['pr'] : ''
);
$total_price = 0;
ohbeReservationFormHandle();
$api_errors = ohbeReservationFormHandle();
$errors = ohbeReservationErrors($api_errors);
?>

<div class="content-area ohbe-page">
    <section class="container">
        <?php if (is_array($redforts_data) &&
            OHBE_Main::getSettings('api_code')): ?>
            <h3 class=ohbe-acco-selected-list-title>
                <?php echo _e('Selected accommodations', 'ohbe'); ?>
            </h3>
            <form method=POST>
                <div class=booking-confirmation-summary>
                    <div class=accommodation-booked-list>
                    <?php OHBE_Reservation::printOscarAccommodationsReservation(
                        $total_price,
                        $redforts_data['rates']
                    ); ?>
                    </div>
                    <div class=accommodation-booked-list-bottom>
                        <button type=submit id=modify-btn
                            name=modify_submit class="btn-ohbe clear">
                            <span class="dashicons dashicons-undo"></span>
                            <?php _e('Modify', 'ohbe'); ?>
                        </button>
                        <div class=total-block style="display:inline-block;">
                            <div class=ohbe-title>
                                <?php _e('Total price', 'ohbe'); ?>:
                            </div>
                            <div class=value>
                                <?php echo OHBE_Tools::formatPrice(
                                    $total_price
                                ); ?>
                            </div>
                        </div>
                        <div class=clearfix></div>
                    </div>
                    <input type=hidden id=ohbe-accommodations-input
                        name=accommodations>
                    <div class=clearfix></div>
                </div>
            </form>

            <form method=POST>
                <div class=client-data>
                    <?php if (OHBE_Main::getSettings('test_mode')): ?>
                        <div class="alert alert-danger">
                            <?php _e(
                                'Test mode active: It is not possible to '
                                . 'make a booking at this time.'
                                , 'ohbe'
                            ); ?>
                        </div>
                    <?php endif;
                    if (isset($api_errors) && is_array($api_errors)):
                        foreach ($api_errors as $api_error): ?>
                            <div class='alert alert-danger'>
                                <?php echo $api_error['text']; ?>
                            </div>
                        <?php endforeach;
                    elseif (isset($api_errors) && $api_errors == "wrongDate"): ?>
                        <div class="alert alert-danger">
                            <?php echo $errors->get_error_message(
                                'ohbe_card_expires'
                            ); ?>
                        </div>
                    <?php endif ?>
                    <h3 class=ohbe-title>
                        <?php _e('Personal data', 'ohbe'); ?>
                    </h3>
                    <?php
                        OHBE_Reservation::printReservationFields(
                            'personal',
                            $redforts_data,
                            $errors
                        );
                        OHBE_Reservation::printCreditCardDataHeader(
                            $redforts_data
                        );
                        OHBE_Reservation::printReservationFields(
                            'card',
                            $redforts_data, $errors
                        );
                    if (OHBE_Main::getSettings('notes')): ?>
                    <h3 class=ohbe-title>
                        <?php _e('Comments or requests', 'ohbe'); ?>
                    </h3>
                    <div class="reservation-field full-width">
                        <div class=ohbe-comments>
                            <textarea id=ohbe-notes class=ohbe-field
                            name=ohbe_notes></textarea>
                        </div>
                    </div>
                    <?php endif;
                        echo OHBE_Reservation::renderPrivacyStatement($redforts_data);
                        echo OHBE_Reservation::renderConsent($redforts_data);
                        echo OHBE_Reservation::renderConditions($redforts_data);
                    ?>
                    <input type=hidden name=action value=reservation_form>
                    <div class=btn-booking-wrapper>
                        <button type=submit name=reservation_submit
                            class="btn-ohbe btn-booking">
                            <?php _e('Confirm', 'ohbe'); ?>
                        </button>
                    </div>
                </div>
                <input type=hidden id=ohbe-accommodations-input
                    name=accommodations>
            </form>
            <?php
                if (
                    OHBE_Main::getSettings('conditions')
                    && isset($redforts_data['checkinout'])
                    || isset($redforts_data['conditions'])
                ):
                    $content = '';
                    if (isset($redforts_data['checkinout'])):
                        $content .= sprintf(
                            '<h4>%s</h4>'
                            . '<p class=time-text>%s</p>',
                            __('Check in/out conditions', 'ohbe'),
                            nl2br(htmlspecialchars($redforts_data['checkinout']))
                        );
                    endif;
                    if (isset($redforts_data['conditions'])):
                        $content .= sprintf(
                            '<h4>%s</h4>'
                            . '<div>%s</div>',
                            __('Conditions', 'ohbe'),
                            nl2br(htmlspecialchars($redforts_data['conditions']))
                        );
                    endif;
                    echo OHBE_Reservation::renderModal(
                        'ohbe-conditions',
                        __('Reservation conditions', 'ohbe'),
                        $content
                    );
                    endif;
                    if (isset($redforts_data['privacy'])):
                        $title = __('Privacy statement', 'ohbe');
                        $content = sprintf(
                            '<p>%s</p>',
                            nl2br(htmlspecialchars($redforts_data['privacy']))
                        );
                        echo OHBE_Reservation::renderModal(
                            'ohbe-privacy',
                            __('Privacy statement', 'ohbe'),
                            $content
                        );
                    endif;
                else:
                    printf(
                        '<div class="alert alert-danger" '
                        . 'style="padding:10px;">%s</div>',
                        __(
                            'Your connection code is either wrong or not set yet.'
                            , 'ohbe'
                        )
                    );
                endif;
            ?>
    </section>
</div>

<?php get_footer(); ?>
